%{
    This file is part of StemCellQC, a video bioinformatics software
    toolkit for analysis of phase contrast microscopy videos.
    Copyright 2013-2015 

    StemCellQC is free software: you can redistribute it and/or 
    modify it under the terms of the GNU General Public License as 
    published by the Free Software Foundation, either version 3 of the 
    License, or (at your option) any later version.

    StemCellQC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with StemCellQC.  If not, see <http://www.gnu.org/licenses/>.
%}

function [res cc] = fun_returnLargestObj( inputImage )

if ~islogical( inputImage )
    error( 'returnLargestObj: Attempting to run connected components on an image that was not segmented!' );
end

cc = bwlabel( inputImage );

tcc = cc(:);
tcc( tcc == 0 ) = [];
largestObj = mode( tcc(:) );

res = zeros( size( cc ) );
res( cc == largestObj ) = 1;