%{
    This file is part of StemCellQC, a video bioinformatics software
    toolkit for analysis of phase contrast microscopy videos.
    Copyright 2013-2015 Vincent On. [vincenton001-at-gmail.com]

    StemCellQC is free software: you can redistribute it and/or 
    modify it under the terms of the GNU General Public License as 
    published by the Free Software Foundation, either version 3 of the 
    License, or (at your option) any later version.

    StemCellQC is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with StemCellQC.  If not, see <http://www.gnu.org/licenses/>.
%}

% function computes the change for specific perimeters between
% each frame

function d_stats = stats_dt()
global features


d_area = diff( cell2mat( features( 2:end,3 )));
d_peri = diff( cell2mat( features( 2:end,4 )));

centroid = cell2mat(features(2:end,5:6));
d_centroid = zeros(size(d_area));

for i = 1:(length(centroid(:,1))-1);
    d_centroid(i,1) = pdist([centroid(i,:); centroid(i+1,:)]);
end
    

d_stats = [ d_area d_peri d_centroid];

